<?php

class Achievements{

	private $achievements = [];
	private $user = null;
	private $achievements_table = '#__wow_guild_user_achievement';
	private $db;

	public function __construct($user){
		$this->user = $user;
		$this->db = JFactory::getDbo();
	}

	public function addAchievement($id, $name, $completed){
		$achievement = [
			'achievement_id' => $id,
			'achievement_name' => $name,
			'achievement_completed' => $completed
		];
		$this->achievements[] = $achievement;
	}

	private function resetUserAchievements(){
		$query = $this->db->getQuery(true);
		$conditions = array(
			$this->db->quoteName('wow_user') . ' = ' . $this->user->get('internal_id')
		);
		$query->delete($this->db->quoteName($this->achievements_table));
		$query->where($conditions);
		$this->db->setQuery($query);
		$this->db->execute();
	}

	public function save(){
		if($this->user !== null && !empty($this->achievements)){

			$this->resetUserAchievements();

			foreach($this->achievements as $achievement_value){
				$query = $this->db->getQuery(true);

				$values = [];
				foreach($achievement_value as $key => $params){
					$values[$key] = is_int($params) ? $params : $this->db->quote($params);
				}

				$values['created'] = $this->db->quote(date('Y-m-d H:i:s'));
				$values['wow_user'] = $this->user->get('internal_id');

				$query
					->insert($this->db->quoteName($this->achievements_table))
					->columns($this->db->quoteName(array_keys($values)))
					->values(implode(',', $values));

				$this->db->setQuery($query);
				$this->db->execute();
			}
		}
	}
}
